#!/usr/bin/perl -w
#use XML::Parser;

#$p1 = new XML::Parser(Style => 'Debug');
#$p1->parsefile('index.html');

#$p1->parse('<foo id="me">Hello World</foo>');

package ListaParser;

use HTML::Parser;

@ISA = qw(HTML::Parser);

sub new() {
  my $h = HTML::Parser->new;
  bless $h;
  $h->{data} = [];
  return $h;
}

sub start( $$$$$ ) {
  my ($self, $tag, $attr, $attrSeq, $origText) = @_;
  if ($tag eq "a") {
    if (exists $attr->{href}) {
      $self->{location} = $attr->{href};
      $self->{inhref}   = 1;
      $self->{text}     = "";
    }
  }
}

sub text( $$ ) {
  my ($self, $text) = @_;
  $self->{text} .= $text;
}

sub end( $$$ ) {
  my ($self, $tag, $origText) = @_;
  if ($tag eq "a") {
    if (defined $self->{inhref}) {
      $self->{inhref} = undef;
#      print "$self->{location}: $self->{text}\n";
      push @{$self->{data}}, [$self->{location}, $self->{text}];
    }
  }
}

return 1;
